package com.chargeitpro.chargeitpro_demopos;

import android.app.AlertDialog;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.EditText;

import model.MobileActivateResponse;

public class ActivateActivity extends AppCompatActivity {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_activate);
    }

    public void activateItButtonClick(View view) {
        AsyncTask.execute(new Runnable() {
            @Override
            public void run() {
                // Get the activation key
                EditText activationKeyEditText = (EditText) findViewById(R.id.activationKeyEditText);
                String activationKey = activationKeyEditText.getText().toString();

                try {
                    // Send the request to activate this device
                    MobileActivateResponse mobileActivateResponse = ChargeItProAPI.activateDeviceUsingActivationKey(activationKey);

                    // Store the ConfigurationId
                    SharedPreferences preferences = getApplicationContext().getSharedPreferences("Configuration", Context.MODE_PRIVATE);
                    SharedPreferences.Editor editor = preferences.edit();
                    editor.putString("ConfigurationId", mobileActivateResponse.ConfigurationId);
                    editor.commit();

                    // Get a handler that can be used to post to the main thread
                    Handler mainHandler = new Handler(ActivateActivity.this.getMainLooper());
                    Runnable myRunnable = new Runnable() {
                        @Override
                        public void run() {
                            AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(ActivateActivity.this);
                            alertDialogBuilder.setTitle("Success");
                            alertDialogBuilder.setMessage("This device has been activated and the ConfigurationID has been stored locally.");
                            alertDialogBuilder.setPositiveButton("OK", null);
                            AlertDialog alertDialog = alertDialogBuilder.create();
                            alertDialog.show();
                        }
                    };
                    mainHandler.post(myRunnable);
                } catch (Exception e) {
                    // Get a handler that can be used to post to the main thread
                    Handler mainHandler = new Handler(ActivateActivity.this.getMainLooper());
                    Runnable myRunnable = new Runnable() {
                        @Override
                        public void run() {
                            AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(ActivateActivity.this);
                            alertDialogBuilder.setTitle("Error");
                            alertDialogBuilder.setMessage("Please enter a valid Activation Key. If you do not have an Activation Key, please contact ChargeItPro for help: 1-800-989-2135");
                            alertDialogBuilder.setPositiveButton("OK", null);
                            AlertDialog alertDialog = alertDialogBuilder.create();
                            alertDialog.show();
                        }
                    };
                    mainHandler.post(myRunnable);
                }
            }
        });
    }
}