package com.chargeitpro.chargeitpro_demopos;

import android.content.Intent;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.EditText;

import model.MobileTransactionResponse;

public class RequestSignatureActivity extends AppCompatActivity
{
    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_request_signature);
    }

    public void requestItButtonClick(View view)
    {
        AsyncTask.execute(new Runnable() {
            @Override
            public void run() {
                try {
                    // Get the cashier name
                    EditText cashierEditText = (EditText)findViewById(R.id.requestSignatureCashierNameEditText);
                    String cashierName = cashierEditText.getText().toString();

                    // Create a new mobile transaction
                    MobileTransactionResponse mobileTransactionResponse = ChargeItProAPI.createNewMobileTransaction(RequestSignatureActivity.this, "RequestSignature", null, cashierName, null);

                    // Create the URL that will open the POS app once processing has completed
                    String appUrl = "chargeItProDemoPOSApp://";

                    // Create the URL that will open ChargeItPro with all the necessary information
                    String chargeItProUrl =
                            "chargeitproapp://?mobileTransactionId=" +
                            mobileTransactionResponse.Result.MobileTransactionId +
                            "&appUrl=" +
                            appUrl;

                    // Open ChargeItPro with URL
                    Intent intent = new Intent(Intent.ACTION_VIEW);
                    intent.setData(Uri.parse(chargeItProUrl));
                    intent.putExtra("TRANS_ID", mobileTransactionResponse.Result.MobileTransactionId);
                    startActivity(intent);
                } catch (Exception e) {
                }
            }
        });
    }
}
